> This is a page from the ElevenLabs documentation. For a complete page index, fetch https://elevenlabs.io/docs/llms.txt. For the full documentation in a single file, fetch https://elevenlabs.io/docs/llms-full.txt.

# Elenca strumenti del server MCP

GET https://api.elevenlabs.io/v1/convai/mcp-servers/{mcp_server_id}/tools

Recupera tutti gli strumenti disponibili per una specifica configurazione del server MCP.

Reference: https://elevenlabs.io/docs/api-reference/mcp/list-tools

## Servers

- `https://api.elevenlabs.io` (Production, default)
- `https://api.us.elevenlabs.io` (Production US)
- `https://api.eu.residency.elevenlabs.io` (Production EU)
- `https://api.in.residency.elevenlabs.io` (Production India)
- `https://api.sg.residency.elevenlabs.io` (Production Singapore)

## Request

### Path parameters

- `mcp_server_id` (string, required) — ID del server MCP.

### Query parameters

- `environment` (string, optional, default: production) — Ambiente i cui valori vengono usati quando l'URL del server MCP, gli header o la connessione di autenticazione fanno riferimento a variabili di ambiente. Rispecchia l'ambiente in cui verrebbe eseguita una conversazione; per impostazione predefinita è production.

## Response

### 200

Risposta riuscita

- `success` (boolean, required) — Indica se l'operazione è riuscita.
- `tools` (list of Tool, required) — Un elenco di strumenti disponibili sul server MCP.
- `tool_approval_statuses` (list of MCPToolApprovalStatus, optional) — Stati di approvazione derivati per gli strumenti attualmente rilevati. Popolato solo per i server MCP persistenti che utilizzano l'approvazione per strumento; altrimenti è vuoto.
- `error_message` (string, optional, nullable) — Messaggio di errore se l'operazione non è riuscita.

## Errors

### 422 Unprocessable Entity Error

Errore di convalida

- `detail` (list of ValidationError, optional)

## Types

### Tool

Definizione di uno strumento che il client può chiamare.

- `name` (string, required)
- `inputSchema` (map from string to any, required)
- `title` (string, optional, nullable)
- `description` (string, optional, nullable)
- `execution` (ToolExecution, optional, nullable) — Proprietà relative all'esecuzione di uno strumento (solo 2025-11-25).
- `outputSchema` (map from string to any, optional, nullable)
- `icons` (list of Icon, optional, nullable)
- `annotations` (ToolAnnotations, optional, nullable) — Proprietà aggiuntive che descrivono uno strumento ai client. NOTA: tutte le proprietà in ToolAnnotations sono **suggerimenti**. Non garantiscono una descrizione fedele del comportamento dello strumento, incluse le proprietà descrittive come `title`. I client non devono mai prendere decisioni sull'uso degli strumenti in base a ToolAnnotations ricevute da server non attendibili.
- `_meta` (map from string to any, optional, nullable)

### MCPToolApprovalStatus

Stato di approvazione derivato per uno strumento MCP attualmente rilevato.

- `tool_id` (string, required) — Identificatore canonico dello strumento MCP nel formato mcp:\<server\_id>:\<tool\_name>
- `state` (enum, required) — Se esiste un'approvazione salvata e se corrisponde ancora alla definizione del tool attivo
  - Allowed values: `up_to_date`, `needs_review`, `not_approved`
- `approval_policy` (enum, optional, nullable, default: requires_approval) — Policy di esecuzione archiviata. Impostata quando lo strumento ha un'approvazione.
  - Allowed values: `auto_approved`, `requires_approval`
- `approved_definition` (MCPApprovedToolDefinition, optional, nullable) — Definizione approvata in precedenza, inclusa quando lo strumento richiede una revisione ed esiste una snapshot.

### ValidationError

- `loc` (list of ValidationErrorLocItems, required)
- `msg` (string, required)
- `type` (string, required)

### ToolExecution

Proprietà relative all'esecuzione di uno strumento (solo 2025-11-25).

- `taskSupport` (enum, optional, nullable)
  - Allowed values: `forbidden`, `optional`, `required`

### Icon

Un'icona di dimensioni facoltative da visualizzare in un'interfaccia utente (2025-11-25+).

- `src` (string, required)
- `mimeType` (string, optional, nullable)
- `sizes` (list of string, optional, nullable)
- `theme` (enum, optional, nullable)
  - Allowed values: `light`, `dark`

### ToolAnnotations

Proprietà aggiuntive che descrivono uno strumento ai client. NOTA: tutte le proprietà in ToolAnnotations sono **suggerimenti**. Non garantiscono una descrizione fedele del comportamento dello strumento, incluse le proprietà descrittive come `title`. I client non devono mai prendere decisioni sull'uso degli strumenti in base a ToolAnnotations ricevute da server non attendibili.

- `title` (string, optional, nullable)
- `readOnlyHint` (boolean, optional, nullable)
- `destructiveHint` (boolean, optional, nullable)
- `idempotentHint` (boolean, optional, nullable)
- `openWorldHint` (boolean, optional, nullable)

### MCPApprovedToolDefinition

Snapshot della definizione dello strumento MCP approvata.

- `description` (string, optional, default: ) — La descrizione dello strumento fornita dal server MCP al momento dell'approvazione
- `input_schema` (map from string to any, optional) — Lo schema JSON di input fornito dal server MCP al momento dell'approvazione

### ValidationErrorLocItems

## Examples

**Response**

```json
{
  "success": true,
  "tools": [
    {
      "name": "weather_by_zapier_get_current",
      "inputSchema": {
        "properties": {
          "latitude": {
            "description": "Latitude",
            "type": "string"
          },
          "longitude": {
            "description": "Longitude",
            "type": "string"
          }
        },
        "required": [
          "latitude",
          "longitude"
        ],
        "type": "object"
      },
      "description": "Gets current weather conditions for a location."
    },
    {
      "name": "tool2",
      "inputSchema": {
        "properties": {},
        "type": "object"
      },
      "description": "Description of tool2"
    }
  ],
  "tool_approval_statuses": []
}
```

**SDK Code**

```python
import requests

url = "https://api.elevenlabs.io/v1/convai/mcp-servers/mcp_server_id/tools"

response = requests.get(url)

print(response.json())
```

```javascript
const url = 'https://api.elevenlabs.io/v1/convai/mcp-servers/mcp_server_id/tools';
const options = {method: 'GET'};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.elevenlabs.io/v1/convai/mcp-servers/mcp_server_id/tools"

	req, _ := http.NewRequest("GET", url, nil)

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.elevenlabs.io/v1/convai/mcp-servers/mcp_server_id/tools")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.elevenlabs.io/v1/convai/mcp-servers/mcp_server_id/tools")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.elevenlabs.io/v1/convai/mcp-servers/mcp_server_id/tools');

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.elevenlabs.io/v1/convai/mcp-servers/mcp_server_id/tools");
var request = new RestRequest(Method.GET);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let request = NSMutableURLRequest(url: NSURL(string: "https://api.elevenlabs.io/v1/convai/mcp-servers/mcp_server_id/tools")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```